#include <string.h>

#include "animation.h"

static const Animation animations[] = {
#define x(name, bitmap, frames, frame_count, slowness) \
	{ \
		bitmap, \
		frames, \
		frame_count, \
		slowness \
	},
	animations_xmacro()
#undef x
};

const Animation* get_animation(Animation_ID id) {
	return &animations[id];
}

static const char* animation_names[animation_count] = {
#define x(name, bitmap, frames, frame_count, slowness) \
	#name,
	animations_xmacro()
#undef x
};

const char* get_animation_name(Animation_ID id) {
	return animation_names[id];
}

Animation_ID get_animation_id(const char* name) {
	int i;
	for (i = 0; i < animation_count; i++) {
		if (!strcmp(name, animation_names[i])) {
			return (Animation_ID)i;
		}
	}
	return animation_count;
}
