#ifndef animation_h
#define animation_h

#include "asset.h"
#include "config.h"
#include "rect.h"

#define frames_demonbird_fly_left \
	{ 0,  8, 13, 8 }, \
	{ 13, 8, 13, 8 }, \
	{ 26, 8, 13, 8 }, \
	{ 39, 8, 13, 8 }, \
	{ 52, 8, 13, 8 }, \
	{ 65, 8, 13, 8 }, \
	{ 78, 8, 13, 8 }, \
	{ 65, 8, 13, 8 }, \
	{ 52, 8, 13, 8 }, \
	{ 39, 8, 13, 8 }, \
	{ 26, 8, 13, 8 }, \
	{ 13, 8, 13, 8 }

#define frames_demonbird_fly_right \
	{ 0,  0, 13, 8 }, \
	{ 13, 0, 13, 8 }, \
	{ 26, 0, 13, 8 }, \
	{ 39, 0, 13, 8 }, \
	{ 52, 0, 13, 8 }, \
	{ 65, 0, 13, 8 }, \
	{ 78, 0, 13, 8 }, \
	{ 65, 0, 13, 8 }, \
	{ 52, 0, 13, 8 }, \
	{ 39, 0, 13, 8 }, \
	{ 26, 0, 13, 8 }, \
	{ 13, 0, 13, 8 }

#define frames_demonbird_idle_left \
	{ 13, 16,  13, 8 }
#define frames_demonbird_idle_right \
	{ 0,  16, 13, 8 } \

#define frames_transition_fade_in \
	{ 0,   4, 16, 16 }, \
	{ 16,  4, 16, 16 }, \
	{ 32,  4, 16, 16 }, \
	{ 48,  4, 16, 16 }, \
	{ 64,  4, 16, 16 }, \
	{ 80,  4, 16, 16 }, \
	{ 96,  4, 16, 16 }, \
	{ 112, 4, 16, 16 }, \
	{ 128, 4, 16, 16 }, \
	{ 144, 4, 16, 16 }, \
	{ 160, 4, 16, 16 }, \
	{ 176, 4, 16, 16 }, \
	{ 192, 4, 16, 16 }, \
	{ 208, 4, 16, 16 }, \
	{ 224, 4, 16, 16 }, \
	{ 240, 4, 16, 16 }
#define frames_transition_fade_out \
	{ 240, 4, 16, 16 }, \
	{ 224, 4, 16, 16 }, \
	{ 208, 4, 16, 16 }, \
	{ 192, 4, 16, 16 }, \
	{ 176, 4, 16, 16 }, \
	{ 160, 4, 16, 16 }, \
	{ 144, 4, 16, 16 }, \
	{ 128, 4, 16, 16 }, \
	{ 112, 4, 16, 16 }, \
	{ 96,  4, 16, 16 }, \
	{ 80,  4, 16, 16 }, \
	{ 64,  4, 16, 16 }, \
	{ 48,  4, 16, 16 }, \
	{ 32,  4, 16, 16 }, \
	{ 16,  4, 16, 16 }, \
	{ 0,   4, 16, 16 }
#define frames_explosion \
	{ 48, 0,  16, 16 }, \
	{ 32, 0,  16, 16 }, \
	{ 16, 0,  16, 16 }, \
	{ 0,  16, 16, 16 }, \
	{ 16, 16, 16, 16 }, \
	{ 32, 16, 16, 16 }, \
	{ 48, 16, 16, 16 }, \
	{ 0,  32, 16, 16 }, \
	{ 16, 32, 16, 16 }, \
	{ 32, 32, 16, 16 }, \
	{ 48, 32, 16, 16 }, \
	{ 0,  48, 16, 16 }, \
	{ 16, 48, 16, 16 }
#define frames_cop_bullet_hit \
	{ 32, 64, 6,  6  }, \
	{ 38, 64, 6,  6  }, \
	{ 44, 64, 6,  6  }
#define frame_cia_bullet_hit \
	{ 0,  64, 10, 10 }, \
	{ 10, 64, 10, 10 }, \
	{ 20, 64, 10, 10 }
#define frames_lightbar \
	{ 0, 17, 6, 1 }, \
	{ 0, 18, 6, 1 },

#define animations_xmacro() \
	x( \
		animation_demonbird_fly_left, \
		asset_id_char, \
		{ frames_demonbird_fly_left }, \
		12, \
		1 \
	) \
	x( \
		animation_demonbird_fly_right, \
		asset_id_char, \
		{ frames_demonbird_fly_right }, \
		12, \
		1 \
	) \
	x( \
		animation_demonbird_idle_left, \
		asset_id_char, \
		{ frames_demonbird_idle_left }, \
		1, \
		1 \
	) \
	x( \
		animation_demonbird_idle_right, \
		asset_id_char, \
		{ frames_demonbird_idle_right }, \
		1, \
		1 \
	) \
	x( \
		animation_transition_fade_in, \
		asset_id_ui, \
		{ frames_transition_fade_out }, \
		16, \
		1 \
	) \
	x( \
		animation_transition_fade_out, \
		asset_id_ui, \
		{ frames_transition_fade_in }, \
		16, \
		1 \
	) \
	x( \
		animation_explosion, \
		asset_id_fx, \
		{ frames_explosion }, \
		13, \
		1 \
	) \
	x( \
		animation_lightbar, \
		asset_id_prop, \
		{ frames_lightbar }, \
		2, \
		10 \
	) \
	x( \
		animation_cop_bullet_hit, \
		asset_id_fx, \
		{ frames_cop_bullet_hit }, \
		3, \
		1 \
	) \
	x( \
		animation_cia_bullet_hit, \
		asset_id_fx, \
		{ frame_cia_bullet_hit }, \
		3, \
		1 \
	)

typedef enum {
#define x(name, bitmap, frames, frame_count, slowness) \
	name,
	animations_xmacro()
#undef x
	animation_count
} Animation_ID;

typedef struct {
	Asset_ID bitmap;
	Rectangle frames[animation_max_frames];
	int frame_count;
	int slowness;
} Animation;

const Animation* get_animation(Animation_ID id);
const char* get_animation_name(Animation_ID id);
Animation_ID get_animation_id(const char* name);

#endif
