#ifndef arms_h
#define arms_h

#include "world.h"

Entity new_bomb(
	struct World* world,
	int x,
	int y,
	int vx,
	int vy
) {
	Entity e;
	int id;
	CPosition* pos;
	CSprite* sprite;
	CVelocity* vel;
	CBody* body;
	CCollider* col;
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_position |
		ctype_sprite |
		ctype_velocity |
		ctype_collider |
		ctype_body
	);
	add_tags(
		world,
		e,
		tag_bomb |
		tag_gravity |
		tag_bullet |
		tag_destroy_offscreen
	);
	pos = &world->positions[id];
	sprite = &world->sprites[id];
	vel = &world->velocities[id];
	body = &world->bodies[id];
	col = &world->colliders[id];
	init_csprite(sprite, sprite_bomb_down);
	sprite->z = 200;
	pos->x = x;
	pos->y = y;
	vel->x = vx;
	vel->y = vy;
	col->x = 0;
	col->y = 0;
	col->w = sprite->rect.w << fbits;
	col->h = sprite->rect.h << fbits;
	body->grounded = 0;
	return e;
}

#endif
