#include "cfg.h"
#include "cfgparse.h"
#include "config.h"

Cfg global_cfg;

void default_cfg(Cfg* c) {
	c->win_w = default_window_w;
	c->win_h = default_window_h;
	c->resizable = window_resizable;
	c->fullscreen = window_fullscreen;
	c->audio = 1;
}

void init_cfg(Cfg* c, Arena* a, const char* src) {
	cfg_Object* obj;
	obj = cfg_parse(src, a);
#define parse(name) \
	c->name = find_int_default(obj, #name, c->name)
	parse(win_w);
	parse(win_h);
	parse(resizable);
	parse(fullscreen);
	parse(audio);
#undef parse
}

Cfg* get_cfg(void) {
	return &global_cfg;
}
