#ifndef config_h
#define config_h

/* Game engine config. */

#define game_name "Crow Buys Ketamine"

#define savefile_name "game.sav"
#define cfgfile_name  "crow.cfg"

#define default_window_scale 4
#define default_window_w (320 * default_window_scale)
#define default_window_h (240 * default_window_scale)
#define ms_per_frame 20
#define window_resizable 1
#define window_fullscreen 0
#define hide_mouse 0

#define renderer_w 320
#define renderer_h 240

#define rcache_enable 1
#define rcache_cell_w 32
#define rcache_cell_h 16
#define rcache_gw (renderer_w / rcache_cell_w)
#define rcache_gh (renderer_h / rcache_cell_h)
#define rcache_cmd_buf_size (1024 * 1024)
#define rcache_hash_seed 2166136261

#define audio_buffer_size 256
#define audio_sample_rate 8000

#ifdef DEBUG
/* I need more memory in debug mode because some tools
 * use a lot of heap memory. */
#define memory_heap_size  (1024 * 1024 * 8)
#else
#define memory_heap_size  (1024 * 1024 * 4)
#endif
#define memory_size       (memory_heap_size + (1024 * 1024 * 16))
#if defined(is64bit) && is64bit
#define allocation_default_alignment 8
#else
#define allocation_default_alignment 4
#endif

#define level_loader_memory (1024 * 1024)
#define cutscene_loader_memory (1024 * 1024)
#define sound_memory (1024 * 1024 * 6)
#define song_memory (1024 * 1024 * 4)

#define animation_max_frames 16

#define max_entities 600
#define max_components 32
#define max_entity_children 3

#define gamestate_memory 1024

#define max_menu_uptr 4
#define max_menu_items 16
#define max_menu_item_label 24

#define cutscene_handle_size 8
#define cutscene_max_running 8
#define cutparse_buffer_size 1024 * 512

/* Debugging config. */
#ifdef DEBUG
#define use_system_malloc 0
/*#define force_level "data/boss.lvl"*/
#define force_credits 0
#define force_bomb 0
#ifndef enable_profiler
#define enable_profiler 0
#endif
#endif

/* IMGUI config. */
#define enable_imgui enable_mouse && 1

/* Editor config. */
#define enable_editor 0
#define cutscene_editor_timeline_el_w 3
#define cutscene_editor_timeline_el_h 5
#define cutscene_editor_channels cutscene_max_running

#define enable_savegame 1


#endif
