#include <stdio.h>

#include "animation.c"
#include "boss_type.c"
#include "cfgparse.c"
#include "config.h"
#include "cutparse.c"
#include "cutscene.h"
#include "mapobject.c"
#include "memory.c"
#include "sprite.c"
#include "std_printers.c"

#define convcutscene_memory (1024 * 1024 * 8)

int main(int argc, char** argv) {
	int size;
	FILE* infile, * outfile;
	char* src;
	cfg_Object* obj;
	Cutscene* s;
	Arena arena;

	if (argc < 3) {
		fprintf(stderr, "Usage: %s infile outfile.\n", argv[0]);
		return 1;
	}

	infile = fopen(argv[1], "r");
	if (!infile) {
		fprintf(stderr, "Failed to open %s.\n", argv[1]);
		return 2;
	}

	outfile = fopen(argv[2], "wb");
	if (!outfile) {
		fprintf(stderr, "Failed to open %s.\n", argv[2]);
		return 3;
	}

	fseek(infile, 0, SEEK_END);
	size = ftell(infile);
	rewind(infile);

	src = malloc(size);
	size = fread(src, 1, size, infile);
	src[size] = 0;

	init_arena(
		&arena,
		malloc(convcutscene_memory),
		convcutscene_memory);
	obj = cfg_parse(src, &arena);
	s = arena_alloc(&arena, sizeof *s);
	s->buf_size = 0;
	s->buf = arena_alloc(&arena, 1);
	cutscene_load_cfg(
		s,
		obj,
		&arena
	);
	fwrite("CUTS", 4, 1, outfile);
	fwrite(&s->endframe, sizeof s->endframe, 1, outfile);
	fwrite(s->buf, 1, s->buf_size, outfile);
	free(src);
	free(arena.buffer);

	fclose(outfile);
	fclose(infile);
	return 0;
}
