#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "game_config.h"
#include "gen.h"

static Room_Template_Tile char2tile(char c) {
	switch (c) {
		case '#': return rt_tile_wall;
		case '+': return rt_tile_door;
		case '-': return rt_tile_platform;
		case 'w': return rt_tile_water;
		default:  return rt_tile_air;
	}
}

int main(int argc, char** argv) {
	int i, w, h, r, rc, len;
	char line[1024];
	FILE* infile, * outfile;
	Room_Template_Tile tile;

	if (argc < 3) {
		fprintf(stderr, "Usage: %s infile outfile.\n", argv[0]);
		return 1;
	}

	infile = fopen(argv[1], "r");
	if (!infile) {
		fprintf(stderr, "Failed to open %s.\n", argv[1]);
		return 2;
	}

	outfile = fopen(argv[2], "wb");
	if (!outfile) {
		fprintf(stderr, "Failed to open %s.\n", argv[2]);
		return 3;
	}

	r = 0x7fffffff;
	rc = 0;
	fwrite(&rc, 4, 1, outfile);
	while (fgets(line, sizeof line, infile)) {
		len = strlen(line);
		while (line[len - 1] == '\n') { len--; }
		if (!memcmp(line, "#room", 5)) {
			rc++;
			r = 0;
		} else if (!memcmp(line, "w:", 2)) {
			w = strtol(line + 2, 0, 10);
			w *= room_width;
			fwrite(&w, 4, 1, outfile);
		} else if (!memcmp(line, "h:", 2)) {
			h = strtol(line + 2, 0, 10);
			h *= room_height;
			fwrite(&h, 4, 1, outfile);
			r++;
		} else if (r < h && len == w) {
			for (i = 0; i < len; i++) {
				tile = char2tile(line[i]);
				fwrite(&tile, 1, 1, outfile);
			}
		}
	}
	fseek(outfile, 0, SEEK_SET);
	fwrite(&rc, 4, 1, outfile);

	fclose(outfile);
	fclose(infile);
	return 0;
}
