#include "asset.h"
#include "debuginfo.h"
#include "memory.h"
#include "plat.h"
#include "rcache.h"
#include "render.h"
#include "standard.h"
#include "world.h"

void render_debuginfo(const World* world) {
	int x, y, h, t, i;
	const Fixed_Font* font;
	char buf[64];

#define ren() \
	rc_add_cmd_rffont_text( \
		font, \
		x, \
		y, \
		buf \
	); y += h;

	font = get_smol_font();
	h = font->char_h + 1;
	x = 12;
	y = 12;

	t = get_stack_usage();
	i =  string_copy(buf, "Stack: ");
	i += int_to_buf(t, buf + i);
	i += string_copy(buf + i, "/");
	i += int_to_buf(memory_size, buf + i);
	ren();

	t = get_heap_usage();
	i =  string_copy(buf, "Heap:  ");
	i += int_to_buf(t, buf + i);
	i += string_copy(buf + i, "/");
	i += int_to_buf(memory_heap_size, buf + i);
	ren();

	t = world->entity_count;
	i =  string_copy(buf, "Entities (current) : ");
	i += int_to_buf(t, buf + i);
	ren();

	t = world->created_count;
	i =  string_copy(buf, "Entities (all time): ");
	i += int_to_buf(t, buf + i);
	ren();

	t = plat_fps();
	i =  string_copy(buf, "FPS: ");
	i += int_to_buf(t, buf + i);
	rc_add_cmd_rffont_text(
		font,
		x,
		y,
		buf
	); y += h;
}
