#include "components.h"
#include "fx.h"
#include "maths.h"
#include "sprite.h"
#include "world.h"
/*
Entity new_question(World* world, int x, int y) {
	Entity e;
	int id;
	CPosition* pos;
	CSprite* sprite;
	CVelocity* vel;
	CLifetime* life;

	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_position |
		ctype_sprite   |
		ctype_lifetime |
		ctype_velocity
	);
	pos = &world->positions[id];
	sprite = &world->sprites[id];
	vel = &world->velocities[id];
	life = &world->lifetimes[id];
	world->tags[id] |= tag_gravity;
	pos->x = x;
	pos->y = y;
	init_csprite(sprite, sprite_question);
	sprite->z = 0;
	vel->x = 0;
	vel->y = -f1 * 2;
	life->life = 15;
	return e;
}

Entity new_slash(
	World* world,
	Entity parent,
	Animation_ID anim
) {
	Entity e;
	int id;
	CAnimated* animated;
	CFollow* follow;
	CPosition* pos;
	CSprite* sprite;
	CCollider* col;
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_animated |
		ctype_position |
		ctype_follow |
		ctype_sprite |
		ctype_collider
	);
	add_tags(
		world,
		e,
		tag_trigger |
		tag_destroy_on_anim_done |
		tag_friend_slash
	);
	animated = &world->animated[id];
	follow = &world->follows[id];
	pos = &world->positions[id];
	sprite = &world->sprites[id];
	col = &world->colliders[id];
	sprite->z = 300;
	animated->id = anim;
	animated->frame = 0;
	animated->timer = 0;
	follow->parent = parent;
	follow->x = 0;
	follow->y = 0;
	pos->x = 0;
	pos->y = 0;
	col->x = 0;
	col->y = 4 << fbits;
	col->w = 16 << fbits;
	col->h = 8 << fbits;
	return e;
}


void blood_system(World* world) {
	general_system_vars
	const CVelocity* vel;
	CSprite* sprite;
	Sprite_ID ns;
	general_system(
		ctype_blood |
		ctype_velocity |
		ctype_sprite)
		vel = &world->velocities[i];
		sprite = &world->sprites[i];
		ns = sprite_blood_k;
		if (absolute(vel->y) > absolute(vel->x)) {
			if (vel->y < 0) {
				if (vel->x < 0) {
					ns = sprite_blood_hk;
				} else if (vel->x > 0) {
					ns = sprite_blood_kl;
				} else {
					ns = sprite_blood_k;
				}
			} else {
				if (vel->x < 0) {
					ns = sprite_blood_hj;
				} else if (vel->x > 0) {
					ns = sprite_blood_lj;
				} else {
					ns = sprite_blood_j;
				}
			}
		} else {
			if (vel->x < 0) {
				if (vel->y < 0) {
					ns = sprite_blood_hk;
				} else if (vel->y > 0) {
					ns = sprite_blood_kl;
				} else {
					ns = sprite_blood_k;
				}
			} else {
				if (vel->y < 0) {
					ns = sprite_blood_hj;
				} else if (vel->y > 0) {
					ns = sprite_blood_lj;
				} else {
					ns = sprite_blood_j;
				}
			}
		}
		init_csprite(sprite, ns);
	}
}*/

Entity new_blood(
	World* world,
	int x,
	int y,
	int vx,
	int vy,
	int spr
) {
	Entity e;
	int id;
	CPosition* pos;
	CSprite* sprite;
	CVelocity* vel;
	CFriction* fric;
	CCollider* col;
	CBody* body;
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_position |
		ctype_velocity |
		ctype_sprite |
		ctype_friction |
		ctype_body |
		ctype_collider |
		ctype_blood
	);
	add_tags(
		world,
		e,
		tag_dynamic |
		tag_gravity |
		tag_destroy_offscreen
	);
	pos = &world->positions[id];
	vel = &world->velocities[id];
	sprite = &world->sprites[id];
	fric = &world->frictions[id];
	col = &world->colliders[id];
	body = &world->bodies[id];
	pos->x = x;
	pos->y = y;
	vel->x = vx;
	vel->y = vy;
	col->x = 0;
	col->y = 0;
	col->w = 2 << fbits;
	col->h = 2 << fbits;
	fric->amt = blood_friction << 1;
	init_csprite(sprite, spr);
	sprite->z = 0;
	body->grounded = 0;
	return e;
}

void new_blood_splatter(
	struct World* world,
	int x,
	int y,
	int vx,
	int vy
) {
	int amt, i, rvx, rvy;
	Sprite_ID spr;
	amt = 50;
	for (i = 0; i < amt; i++) {
		rvx = vx + rand_range(-(5 << fbits), 5 << fbits);
		rvy = vy + rand_range(-(7 << fbits), 7 << fbits);
		spr = rand_range(sprite_blood_small, sprite_organ_c);
		new_blood(world, x, y, rvx, rvy, spr);
	}
}

Entity new_explosion_particle(
	struct World* world,
	int x,
	int y,
	int vx,
	int vy
) {
	Entity e;
	int id;
	CAnimated* animated;
	CPosition* pos;
	CSprite* sprite;
	CVelocity* vel;
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_animated |
		ctype_position |
		ctype_sprite |
		ctype_velocity
	);
	add_tags(
		world,
		e,
		tag_destroy_on_anim_done
	);
	animated = &world->animated[id];
	pos = &world->positions[id];
	sprite = &world->sprites[id];
	vel = &world->velocities[id];
	sprite->z = 300;
	animated->id = animation_explosion;
	animated->frame = 0;
	animated->timer = 0;
	pos->x = x;
	pos->y = y;
	vel->x = vx;
	vel->y = vy;
	return e;
}

Entity new_impact(
	struct World* world,
	int x,
	int y,
	int anim
) {
	Entity e;
	int id;
	CAnimated* animated;
	CPosition* pos;
	CSprite* sprite;
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_animated |
		ctype_position |
		ctype_sprite
	);
	add_tags(
		world,
		e,
		tag_destroy_on_anim_done
	);
	animated = &world->animated[id];
	pos = &world->positions[id];
	sprite = &world->sprites[id];
	sprite->z = 300;
	animated->id = anim;
	animated->frame = 0;
	animated->timer = 0;
	pos->x = x;
	pos->y = y;
	return e;
}

static Entity new_explosion_hitbox(
	World* world,
	int x,
	int y,
	int w,
	int h
) {
	Entity e;
	int id;
	CPosition* pos;
	CCollider* col;
	CVelocity* vel;
	CLifetime* lifetime;
	CBody* body;
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_position |
		ctype_collider |
		ctype_body |
		ctype_velocity |
		ctype_lifetime
	);
	add_tags(
		world,
		e,
		tag_enemy    |
		tag_killzone
	);
	pos = &world->positions[id];
	col = &world->colliders[id];
	body = &world->bodies[id];
	vel = &world->velocities[id];
	lifetime = &world->lifetimes[id];
	pos->x = x;
	pos->y = y;
	col->x = 0;
	col->y = 0;
	col->w = w;
	col->h = h;
	vel->x = 0;
	vel->y = 0;
	body->grounded = 0;
	lifetime->life = 2;
	return e;
}

void new_explosion(
	struct World* world,
	int x,
	int y
) {
	int amt, i, rvx, rvy;
	amt = 10;
	for (i = 0; i < amt; i++) {
		rvx = rand_range(-(1 << fbits), 1 << fbits);
		rvy = rand_range(-(2 << fbits), 2 << fbits);
		new_explosion_particle(
			world,
			x,
			y,
			rvx,
			rvy
		);
	}
	new_explosion_hitbox(
		world,
		x - explosion_radius,
		y - explosion_radius,
		explosion_radius * 2,
		explosion_radius * 2
	);
}
