#include "asset.h"
#include "gamestate.h"
#include "plat.h"
#include "rcache.h"
#include "render.h"
#include "world.h"

void gamestate_gameover_init(
	Gamestate* gamestate,
	World* world
) {
	(void)gamestate;
	(void)world;
}

void gamestate_gameover_update(
	Gamestate* gamestate,
	World* world
) {
	if (any_btn_just_pressed()) {
		if (file_exists(savefile_name)) {
			transition_load(gamestate, world);
		} else
			transition_level(
				gamestate,
				"level1.lvl",
				world,
				gamestate_type_general
			);
	}
}

void gamestate_gameover_render(
	Gamestate* gamestate,
	World* world
) {
	const Sprite* s;
	const Fixed_Font* sfont;
	const Colour grey = { 200, 200, 200, 255 };
	(void)gamestate;
	(void)world;
	s = get_sprite(sprite_game_over);
	sfont = get_smol_font();
	rc_add_cmd_bmp(
		get_bitmap(s->bitmap),
		renderer_w / 2 - s->rect.w / 2,
		renderer_h / 2 - s->rect.h / 2,
		&s->rect
	);
	rc_add_cmd_rffont_text_col(
		sfont,
		renderer_w / 2 - 40,
		150,
		"press any button",
		grey
	);
}
