#include <string.h>

#include "item.h"
#include "sprite.h"
#ifdef DEBUG
#include "plat.h"
#endif

int get_item_sprite(Item item) {
	switch (item) {
#define x(name, sprite)\
	case item_ ## name: return sprite;
		item_xmacro()
#undef x
		default:
#ifdef DEBUG
			print_err("Bad item.\n");
			pbreak(error_gameplay_error);
#endif
		return 0;
	}
}

const char* get_item_name(Item item) {
	switch (item) {
#define x(name, sprite)\
	case item_ ## name: return #name;
		item_xmacro()
#undef x
		default:
#ifdef DEBUG
			print_err("Bad item.\n");
			pbreak(error_gameplay_error);
#endif
		return 0;
	}
}

Item get_item_by_name(const char* name) {
#define x(n, sprite)\
	if (!strcmp(#n, name)) return item_ ## n;
	item_xmacro()
#undef x
#ifdef DEBUG
	print_err("Bad item name.\n");
	pbreak(error_gameplay_error);
#endif
	return 0;
}
