#ifndef maths_h
#define maths_h

#define fbits 9
#define fscale_lower_limit 16
#define fscale_upper_limit 900
#define fscale_factor 16
#define f1   (1 << fbits)

#define mini(a_, b_) ((a_) < (b_) ? (a_) : (b_))
#define maxi(a_, b_) ((a_) > (b_) ? (a_) : (b_))
#define sign(n_) ((n_ < 0) ? -1 : 1)

#define clamp(v_, min_, max_) (maxi(min_, mini(max_, v_)))

int absolute(int x);
int fsin(int t);
int fcos(int t);
int ftan(int t);
int flerp(int a, int b, int t);
int fsqrt(int v);

int vec_dot(int ax, int ay, int bx, int by);
int vec_len(int x, int y);
void vec_minise(int* x, int* y);
void vec_nrmise(int* x, int* y);
void vec_scale(int* x, int* y, int s);

void seed_rng(unsigned seed);
unsigned get_seed();
unsigned rng();
int rand_range(int a, int b);
int randf();

#endif
