#ifndef menu_h
#define menu_h

#include "config.h"

struct Menu;

typedef void (*Menu_Callback)(struct Menu*, int);

typedef struct {
	char label[max_menu_item_label];
	Menu_Callback clbk;
} Menu_Item;

typedef struct Menu {
	Menu_Item items[max_menu_items];
	int item_count, selected;
	void* uptr[max_menu_uptr];
} Menu;

void init_menu(Menu* menu);
void menu_add(
	Menu* menu,
	const char* label,
	Menu_Callback clbk
);
void menu_select(Menu* menu, int id);
void menu_update(Menu* menu);
void menu_draw(const Menu* menu);

#endif
