#include "config.h"
#include "fx.h"
#include "game_config.h"
#include "world.h"
/*
Entity new_ghast(World* world, int x, int y) {
	Entity e;
	int id;
	CAnimated* animated;
	CCollider* col;
	CFace* face;
	CPosition* pos;
	CSprite* sprite;
	CVelocity* vel;
	CFriction* fric;
	CDamageable* dam;
	CMonster* mons;
	CListener* list;
	CBody* body;
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_position |
		ctype_velocity |
		ctype_animated |
		ctype_sprite   |
		ctype_collider |
		ctype_body     |
		ctype_face     |
		ctype_ghast    |
		ctype_friction |
		ctype_damageable |
		ctype_monster  |
		ctype_listener
	);
	add_tags(
		world,
		e,
		tag_gravity |
		tag_dynamic |
		tag_enemy
	);
	pos = &world->positions[id];
	animated = &world->animated[id];
	vel = &world->velocities[id];
	col = &world->colliders[id];
	sprite = &world->sprites[id];
	face = &world->faces[id];
	fric = &world->frictions[id];
	dam = &world->damageables[id];
	mons = &world->monsters[id];
	list = &world->listeners[id];
	body = &world->bodies[id];
	pos->x = x;
	pos->y = y;
	vel->x = 0;
	vel->y = 0;
	col->x = 3 << fbits;
	col->y = 3 << fbits;
	col->w = 10 << fbits;
	col->h = 13 << fbits;
	dam->hurting = 0;
	dam->hp = 3;
	fric->amt = player_friction;
	animated->id = animation_ghast_idle_right;
	animated->frame = 0;
	animated->timer = 0;
	sprite->z = 100;
	mons->timer = 0;
	body->grounded = 0;
	*face = face_right;
	list->id[0] = event_id_die;
	list->fire[0] = handler_id_die;
	list->id[1] = event_id_trigger;
	list->fire[1] = handler_id_ghast_trigger;
	list->count = 2;
	list->e = -1;
	return e;
}*/

static void base_monster_system(World* world) {
	general_system_vars
	CMonster* mons;
	general_system(ctype_monster)
		mons = &world->monsters[i];
		mons->timer++;
	}
}

static void corpse_system(World* world) {
	general_system_vars
	int dirty = 0;
	const CPosition* pos;
	const CVelocity* vel;
	const CCorpse* corpse;
	const CBody* body;
	general_system(
		ctype_position |
		ctype_velocity |
		ctype_corpse
	)
		pos = &world->positions[i];
		vel = &world->velocities[i];
		body = &world->bodies[i];
		corpse = &world->corpses[i];
		if (
			vel->x == 0 &&
			vel->y == 0 &&
			body->grounded < 3
		) {
			map_add_corpse(
				&world->map,
				pos->x >> fbits,
				pos->y >> fbits,
				corpse->sprite
			);
			dirty = 1;
			destroy_entity(world, world->entities[i]);
		}
	}
	if (dirty)
		cache_map(&world->map);
}

static void cop_shoot(World* world, int x, int y) {
	Entity e;
	int id, pid;
	Player* player;
	CPosition* pos, * ppos;
	CSprite* sprite;
	CVelocity* velo;
	CCollider* col;
	CBody* body;
	CImpact* imp;
	player = &world->player;
	if (player->dead) return;
	pid = entity_index(player->e);
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_position |
		ctype_velocity |
		ctype_sprite |
		ctype_collider |
		ctype_body |
		ctype_impact
	);
	add_tags(
		world,
		e,
		tag_enemy |
		tag_destroy_offscreen |
		tag_bullet |
		tag_destroy_collision
	);
	pos = &world->positions[id];
	sprite = &world->sprites[id];
	velo = &world->velocities[id];
	col = &world->colliders[id];
	body = &world->bodies[id];
	imp = &world->impacts[id];
	ppos = &world->positions[pid];
	pos->x = x;
	pos->y = y;
	velo->x = ppos->x - x;
	velo->y = ppos->y - y;
	vec_minise(&velo->x, &velo->y);
	vec_nrmise(&velo->x, &velo->y);
	vec_scale(&velo->x, &velo->y, cop_bullet_speed);
	col->x = 0;
	col->y = 0;
	col->w = 2 << fbits;
	col->h = 2 << fbits;
	imp->anim = animation_cop_bullet_hit;
	body->grounded = 0;
	init_csprite(sprite, sprite_cop_bullet);
}

static void cop_system(World* world) {
	general_system_vars
	const CPosition* pos;
	const CPosition* ppos;
	int mx, my = 10 << fbits;
	CMonster* mons;
	CSprite* spr;
	ppos = &world->positions[
		entity_index(world->player.e)
	];
	general_system(
		ctype_position |
		ctype_cop |
		ctype_monster |
		ctype_sprite
	)
		pos = &world->positions[i];
		mons = &world->monsters[i];
		spr = &world->sprites[i];
		if (pos->x < ppos->x) {
			init_csprite(spr, sprite_cop_right);
			mx = 9 << fbits;
		} else {
			init_csprite(spr, sprite_cop_left);
			mx = 4 << fbits;
		}
		if (mons->timer > cop_fire_cooldown) {
			mons->timer = 0;
			cop_shoot(world, mx + pos->x, my + pos->y);
		}
		mons->timer++;
	}
}

Entity new_corpse(
	World* world,
	int x,
	int y,
	int vx,
	int vy,
	Sprite_ID sprite
) {
	Entity e;
	int id;
	CSprite* spr;
	CPosition* pos;
	CVelocity* vel;
	CFriction* fric;
	CCollider* col;
	CCorpse* corpse;
	CBody* body;
	e = new_entity(world);
	id = entity_index(e);
	add_components(
		world,
		e,
		ctype_position |
		ctype_velocity |
		ctype_body |
		ctype_sprite |
		ctype_friction |
		ctype_collider |
		ctype_corpse
	);
	add_tags(world, e, tag_dynamic | tag_gravity);
	spr = &world->sprites[id];
	pos = &world->positions[id];
	vel = &world->velocities[id];
	fric = &world->frictions[id];
	col = &world->colliders[id];
	corpse = &world->corpses[id];
	body = &world->bodies[id];
	init_csprite(spr, sprite);
	vel->x = vx;
	vel->y = vy;
	pos->x = x;
	pos->y = y;
	fric->amt = player_friction;
	col->x = 0;
	col->y = 0;
	col->w = 16 << fbits;
	col->h = 16 << fbits;
	body->grounded = 0;
	corpse->sprite = sprite;
	return e;
}
/*
void ghast_system(World* world) {
	general_system_vars
	const CPosition* pos;
	const CDamageable* dam;
	const CBody* body;
	CAnimated* anim;
	CMonster* mons;
	CVelocity* vel;
	const CPosition* ppos;
	CFace* face, nf;
	int px, grounded;
	ppos = &world->positions[entity_index(world->player.e)];
	px = ppos->x;
	general_system(
		ctype_position |
		ctype_monster |
		ctype_ghast |
		ctype_animated |
		ctype_damageable |
		ctype_velocity |
		ctype_body |
		ctype_face
	)
		pos = &world->positions[i];
		dam = &world->damageables[i];
		anim = &world->animated[i];
		mons = &world->monsters[i];
		vel = &world->velocities[i];
		body = &world->bodies[i];
		face = &world->faces[i];
		nf = *face;
		grounded = body->grounded < 3;
		if (
			mons->timer > ghast_jump_cooldown &&
			grounded
		) {
			vel->x = ghast_jump_force_x * (pos->x < px ? 1 : -1);
			vel->y = -ghast_jump_force_y;
			mons->timer = 0;
		}
		if (vel->x < 0)
			nf = face_left;
		else if (vel->x > 0)
			nf = face_right;
		*face = nf;
		if (dam->hurting) {
			anim->id = nf == face_left ?
				animation_ghast_hurt_left:
				animation_ghast_hurt_right;
			anim->frame = 0;
		} else if (!grounded) {
			anim->id = nf == face_left ?
				animation_ghast_jump_left:
				animation_ghast_jump_right;
		} else {
			anim->id = nf == face_left ?
				animation_ghast_idle_left:
				animation_ghast_idle_right;
		}
	}
}*/

void monster_system(World* world) {
	base_monster_system(world);
	corpse_system(world);
	cop_system(world);
}
