#include "asset.h"
#include "menu.h"
#include "gamestate.h"
#include "plat.h"
#include "rcache.h"
#include "render.h"
#include "world.h"

static void on_resume_select(Menu* menu, int id) {
	Gamestate* gamestate = menu->uptr[0];
	World* world = menu->uptr[1];
	(void)id;
	switch_gamestate(
		gamestate,
		world,
		gamestate_type_general
	);
}

static void on_quit_select(Menu* menu, int id) {
	(void)menu;
	(void)id;
	plat_quit();
}

extern void render_border(void);

void gamestate_pause_init(
	Gamestate* gamestate,
	World* world
) {
	(void)world;
	gamestate->menu = arena_alloc(
		&gamestate->arena,
		sizeof *gamestate->menu
	);
	init_menu(gamestate->menu);
	menu_add(gamestate->menu, "Resume", on_resume_select);
	menu_add(gamestate->menu, "Quit",   on_quit_select);
	gamestate->menu->uptr[0] = gamestate;
	gamestate->menu->uptr[1] = world;
	menu_select(gamestate->menu, 0);
}

void gamestate_pause_update(
	Gamestate* gamestate,
	World* world
) {
	(void)world;
	if (btn_just_pressed(btn_pause))
		switch_gamestate(
			gamestate,
			world,
			gamestate_type_general
		);
	menu_update(gamestate->menu);
}

void gamestate_pause_render(
	Gamestate* gamestate,
	World* world
) {
	(void)world;
	menu_draw(gamestate->menu);
	render_border();
}
