#include "asset.h"
#include "editor.h"
#include "gamestate.h"
#include "render.h"
#include "sprite_system.h"
#include "systems.h"
#include "world.h"

void gamestate_program_init(
	Gamestate* gamestate,
	World* world
) {
	Player* player;
	(void)gamestate;
	player = &world->player;
	pause_player(player, world);
	init_editor(gamestate->editor);
}

void gamestate_program_update(
	Gamestate* gamestate,
	World* world
) {
	const BM_Font* font;
	font = get_small_font();
	physics_system(world);
	lifetime_system(world);
	follow_system(world);
	animation_system(world);
	sprite_system(gamestate->spr_system, world);
	update_editor(gamestate->editor);
	render_editor(
		gamestate->editor,
		font,
		30,
		50,
		200,
		200
	);
}
