#include "maths.h"
#include "asset.h"
#include "plat.h"
#include "sound.h"
#include "memory.h"

struct {
	Arena* a, sa;
	int ps, sp, ssc;
	const unsigned char* sd;
} sound_sys = { 0 };

void sound_mix(unsigned char* stream, int size) {
	int i;
	const unsigned char* sd;
	sd = sound_sys.sd;
	for (i = 0; i < size; i++) stream[i] = 0;
	if (sound_sys.ssc && sound_sys.ps)
		for (i = 0; i < size; i++) {
			stream[i] += sd[sound_sys.sp++];
			sound_sys.sp %= sound_sys.ssc;
		}
}

void sound_init(Arena* a) {
	sound_sys.a = a;
	init_arena(
		&sound_sys.sa,
		arena_alloc(a, song_memory),
		song_memory
	);
}

void set_song(const char* name) {
	Asset_Data* data;
	if (!name) {
		sound_sys.ssc = 0;
		return;
	}
	clear_arena(&sound_sys.sa);
	data = read_asset_data(name, &sound_sys.sa);
	sound_sys.sp = 0;
	sound_sys.ssc = data->size;
	sound_sys.sd = (unsigned char*)data->buffer;
}

void play_song(int play) {
	sound_sys.ps = play;
}
