#ifndef sprite_h
#define sprite_h

#include "asset.h"
#include "rect.h"

struct CSprite;

#define sprites_xmacro() \
	x(sprite_blood_small) \
	x(sprite_blood_big) \
	x(sprite_organ_a) \
	x(sprite_organ_b) \
	x(sprite_organ_c) \
	x(sprite_icon_close) \
	x(sprite_icon_check) \
	x(sprite_icon_expanded) \
	x(sprite_icon_collapsed) \
	x(sprite_tile_box) \
	x(sprite_copcar_left) \
	x(sprite_copcar_right) \
	x(sprite_cop_left) \
	x(sprite_cop_right) \
	x(sprite_cop_bullet) \
	x(sprite_spike_a) \
	x(sprite_spike_b) \
	x(sprite_spike_c) \
	x(sprite_star_blue_a) \
	x(sprite_star_blue_b) \
	x(sprite_star_blue_c) \
	x(sprite_star_yellow_a) \
	x(sprite_star_yellow_b) \
	x(sprite_star_yellow_c) \
	x(sprite_game_over) \
	x(sprite_bomb) \
	x(sprite_bomb_down) \
	x(sprite_floppy) \
	x(sprite_drugs_sign) \
	x(sprite_dealer) \
	x(sprite_face_null) \
	x(sprite_face_border) \
	x(sprite_face_player) \
	x(sprite_face_dealer) \
	x(sprite_face_cia) \
	x(sprite_cia_head) \
	x(sprite_cia_head_hurt) \
	x(sprite_cia_head_fire) \
	x(sprite_cia_body) \
	x(sprite_border_blood) \
	x(sprite_border_cross) \
	x(sprite_boss_hb_left) \
	x(sprite_boss_hb_middle) \
	x(sprite_boss_hb_middle_full) \
	x(sprite_boss_hb_right) \
	x(sprite_cia_bullet) \
	x(sprite_cloud) \
	x(sprite_cracked_wall)

typedef enum {
#define x(name) name,
	sprites_xmacro()
#undef x
	sprite_count
} Sprite_ID;

typedef struct {
	Asset_ID bitmap;
	Rectangle rect;
} Sprite;

void init_csprite(struct CSprite* sprite, Sprite_ID id);
const Sprite* get_sprite(Sprite_ID id);

const char* get_sprite_name(Sprite_ID id);
Sprite_ID get_sprite_id(const char* name);

#endif
